- [HTTP request](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.request_body)
- [Response body](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.response_body)
  - [JSON representation](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.CreativeAssetMetadata.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.aspect)
- [ValidationRule](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#ValidationRule)
- [Try it!](https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#try-it)

Inserts a new creative asset.

### HTTP request

- Upload URI, for media upload requests:  
  `POST https://dfareporting.googleapis.com/upload/dfareporting/v5/userprofiles/{profileId}/creativeAssets/{advertiserId}/creativeAssets`
- Metadata URI, for metadata-only requests:  
  `POST https://dfareporting.googleapis.com/dfareporting/v5/userprofiles/{profileId}/creativeAssets/{advertiserId}/creativeAssets`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `profileId` | `string (https://developers.google.com/discovery/v1/type-format format)` User profile ID associated with this request. |
| `advertiserId` | `string (https://developers.google.com/discovery/v1/type-format format)` Advertiser ID of this creative. This is a required field. |

### Request body

The request body contains an instance of `https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#body.CreativeAssetMetadata`.

### Response body

CreativeAssets contains properties of a creative asset file which will be uploaded or has already been uploaded. Refer to the creative sample code for how to upload assets and insert a creative.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "assetIdentifier": { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeAssetId`) }, "detectedFeatures": [ enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#Html5Feature`) ], "warnedValidationRules": [ enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#ValidationRule`) ], "clickTags": [ { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#ClickTag`) } ], "id": string, "idDimensionValue": { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/DimensionValue`) }, "richMedia": boolean, "counterCustomEvents": [ { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeCustomEvent`) } ], "exitCustomEvents": [ { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeCustomEvent`) } ], "timerCustomEvents": [ { object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeCustomEvent`) } ], "kind": string } ``` |

| Fields ||
|---|---|
| `assetIdentifier` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeAssetId`)`` ID of the creative asset. This is a required field. |
| `detectedFeatures[]` | ``enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#Html5Feature`)`` List of feature dependencies for the creative asset that are detected by Campaign Manager. Feature dependencies are [features](https://developers.google.com/doubleclick-advertisers/html5features) that a browser must be able to support in order to render your HTML5 creative correctly. This is a read-only, auto-generated field. |
| `warnedValidationRules[]` | ``enum (`https://developers.google.com/doubleclick-advertisers/rest/v5/creativeAssets/insert#ValidationRule`)`` Rules validated during code generation that generated a warning. This is a read-only, auto-generated field. Possible values are: - "`ADMOB_REFERENCED`" - "`ASSET_FORMAT_UNSUPPORTED_DCM`" - "`ASSET_INVALID`" - "`CLICK_TAG_HARD_CODED`" - "`CLICK_TAG_INVALID`" - "`CLICK_TAG_IN_GWD`" - "`CLICK_TAG_MISSING`" - "`CLICK_TAG_MORE_THAN_ONE`" - "`CLICK_TAG_NON_TOP_LEVEL`" - "`COMPONENT_UNSUPPORTED_DCM`" - "`ENABLER_UNSUPPORTED_METHOD_DCM`" - "`EXTERNAL_FILE_REFERENCED`" - "`FILE_DETAIL_EMPTY`" - "`FILE_TYPE_INVALID`" - "`GWD_PROPERTIES_INVALID`" - "`HTML5_FEATURE_UNSUPPORTED`" - "`LINKED_FILE_NOT_FOUND`" - "`MAX_FLASH_VERSION_11`" - "`MRAID_REFERENCED`" - "`NOT_SSL_COMPLIANT`" - "`ORPHANED_ASSET`" - "`PRIMARY_HTML_MISSING`" - "`SVG_INVALID`" - "`ZIP_INVALID`" <br /> |
| `clickTags[]` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#ClickTag`)`` List of detected click tags for assets. This is a read-only, auto-generated field. This field is empty for a rich media asset. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Numeric ID of the asset. This is a read-only, auto-generated field. |
| `idDimensionValue` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/DimensionValue`)`` Dimension value for the numeric ID of the asset. This is a read-only, auto-generated field. |
| `richMedia` | `boolean` True if the uploaded asset is a rich media asset. This is a read-only, auto-generated field. |
| `counterCustomEvents[]` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeCustomEvent`)`` List of counter events configured for the asset. This is a read-only, auto-generated field and only applicable to a rich media asset. |
| `exitCustomEvents[]` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeCustomEvent`)`` List of exit events configured for the asset. This is a read-only, auto-generated field and only applicable to a rich media asset. |
| `timerCustomEvents[]` | ``object (`https://developers.google.com/doubleclick-advertisers/rest/v5/creatives#CreativeCustomEvent`)`` List of timer events configured for the asset. This is a read-only, auto-generated field and only applicable to a rich media asset. |
| `kind` | `string` Identifies what kind of resource this is. Value: the fixed string `"dfareporting#creativeAssetMetadata"`. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/dfatrafficking`

## ValidationRule

Rules that the upload and/or html5 conversion service needs to validate against.

| Enums ||
|---|---|
| `CLICK_TAG_NON_TOP_LEVEL` | Click tag initialization detected but not at the top level of the primary html file. |
| `CLICK_TAG_MISSING` | No click tag detected. |
| `CLICK_TAG_MORE_THAN_ONE` | More than one click tag detected. |
| `CLICK_TAG_INVALID` | Click tag invalid (failed url validation). |
| `ORPHANED_ASSET` | Orphaned asset not referenced. |
| `PRIMARY_HTML_MISSING` | Primary html file missing. |
| `EXTERNAL_FILE_REFERENCED` | Reference to a third-party resource. |
| `MRAID_REFERENCED` | Reference to INAPP MRAID feature. |
| `ADMOB_REFERENCED` | Reference to INAPP ADMOB feature. |
| `FILE_TYPE_INVALID` | Invalid file type referenced. |
| `ZIP_INVALID` | Invalid zip passed in |
| `LINKED_FILE_NOT_FOUND` | A relative file was linked to that wasn't included in zip. |
| `MAX_FLASH_VERSION_11` | Max flash version at 11. |
| `NOT_SSL_COMPLIANT` | Whether the asset uses secure urls or not. |
| `FILE_DETAIL_EMPTY` | File detail empty. |
| `ASSET_INVALID` | Asset is not valid and could not be processed. |
| `GWD_PROPERTIES_INVALID` | GWD properties are invalid. |
| `ENABLER_UNSUPPORTED_METHOD_DCM` | Unsupported Enabler methods in DCM. |
| `ASSET_FORMAT_UNSUPPORTED_DCM` | Asset ad format is unsupported in DCM. |
| `COMPONENT_UNSUPPORTED_DCM` | Component is unsupported in DCM. |
| `HTML5_FEATURE_UNSUPPORTED` | Html5 feature is unsupported. |
| `CLICK_TAG_IN_GWD` | Click tag defined in GWD asset. GWD-published creatives should use exit events instead of defining var clickTag. Defined var clickTags are a symptom of an unsupported workflow, and an error should be thrown. |
| `CLICK_TAG_HARD_CODED` | Whether the asset has hard coded click tag url(s). |
| `SVG_INVALID` | Whether an SVG block could not be parsed. |
| `CLICK_TAG_IN_RICH_MEDIA` | Click tag defined in rich media asset. Rich media creatives should use exit events instead of defining var clickTag. Defined var clickTags are a symptom of an unsupported workflow, and an error should be thrown. |
| `MISSING_ENABLER_REFERENCE` | Rich media primary asset is missing the Enabler reference. |